﻿;24-09-23 sketch
;25-09-23 charsets done, mouse events for canvas
;26-09-23 draw line implemented
;27-09-23 save file implemented
;27-09-23 fill char implemented, fix with display table
;28-09-23 done with keyboard input, done border select, done load files with drag'n'drop
Global *s=AllocateMemory(6000)
Global *f=AllocateMemory(2048)
Global Dim color.l(15)

Global curchar=0;current char
Global curcol=14;current color
Global borderc=6;bordercolor
Global is_lower=0

Global prevx,prevy
Global spa$=GetCurrentDirectory()
Enumeration;gadgets
  #s
  #ch
EndEnumeration

Enumeration;menus
  #file_open
  #file_save
  #file_quit
  #mode_lower
  #mode_upper
  #draw_pen
  #draw_line
  #draw_fill
  #draw_cls
  #char_delete_one
  #char_delete_row
  #char_delete_column
  #char_insert_one
  #char_insert_row
  #char_insert_column
  
  #bc0
  #bc1
  #bc2
  #bc3
  #bc4
  #bc5
  #bc6
  #bc7
  #bc8
  #bc9
  #bc10
  #bc11
  #bc12
  #bc13
  #bc14
  #bc15
EndEnumeration

Global draw_mode=#draw_pen ; type of draw
Global v$="PETSCII paint 0.9"
Restore c64c
For i=0 To 15
  Read.l color(i)
Next i

Procedure draws()
  ;color 14/6
  StartDrawing(CanvasOutput(#s))
  c0=color(borderc)
  For y=0 To 24
    For x=0 To 39
      a.a=PeekA(*s+x+y*40)
      c1=color(PeekA(1000+*s+x+y*40)&15)
      For yy=0 To 7
        b.a=128
        For xx=0 To 7
          If PeekA(*f+a*8+yy)&b
            Box(x*16+xx*2,y*16+yy*2,2,2,c1)
          Else
            Box(x*16+xx*2,y*16+yy*2,2,2,c0)
          EndIf
          b>>1
        Next xx
      Next yy
    Next x
  Next y
  ;--fraw grid
  For i=0 To 39
    For j=0 To 640 Step 2
      Box(i*16,j,1,1,$7F7F7F)
      Box(j,i*16,1,1,$7F7F7F)
    Next j
  Next i
  ;-- mouse cursor
  x = GetGadgetAttribute(#s, #PB_Canvas_MouseX)/16
  y = GetGadgetAttribute(#s, #PB_Canvas_MouseY)/16
  DrawingMode(#PB_2DDrawing_Outlined)
  Box (x*16,y*16,16,16,255)
  StopDrawing()
EndProcedure

Procedure drawch()
  If StartDrawing(CanvasOutput(#ch))
    Box(0,0,255,255,0)
    c1=color(14)
    c0=color(6)
    For y=0 To 15
      For x=0 To 15
        c=PeekA(?petscimap1+(x+y*16)&127+128*is_lower)+(x+y*16)&128
        For yy=0 To 7
          a=PeekA(*f+c*8+yy)
          b=128
          For xx=0 To 7
            If a&b
              Box(x*16+xx*2,y*16+yy*2,2,2,c1)
            Else
              Box(x*16+xx*2,y*16+yy*2,2,2,c0)
            EndIf
            b>>1
          Next xx
        Next yy
      Next x
    Next y
    For i=0 To 15
      Box (i*16,256,16,16,color(i))
    Next i
    ;grid
    For i=0 To 15
      LineXY(i*16,0,i*16,255,0)
      LineXY(0,i*16,255,i*16,0)
    Next i
    ;current color
    Box (curcol*16+4,256+4,8,8,color(curcol)!$FFFFFF)
    ;current char
    DrawingMode(#PB_2DDrawing_Outlined)
    Box(16*(curchar&15),curchar&$F0,16,16,255)
    ;mouse pointer
    x = GetGadgetAttribute(#ch, #PB_Canvas_MouseX)/16
    y = GetGadgetAttribute(#ch, #PB_Canvas_MouseY)/16
    ;Debug Str(x)+","+Str(y)
    Box (x*16,y*16,16,16,$00ff00)
    prevx=x
    prevy=y
    StopDrawing()
  EndIf
EndProcedure

Procedure cls()
  FillMemory(*s,1000,32)
  FillMemory(*s+1000,1000,14)
  draws()
EndProcedure

Procedure putc(x,y)
  If x>=0 And x<40
    If y>=0 And y<25
      PokeA(*s+x+y*40,PeekA(?petscimap1+curchar&127+128*is_lower)|(curchar&128))
      PokeA(*s+1000+x+y*40,curcol)
    EndIf
  EndIf
EndProcedure

Procedure prepchar()
  CopyMemory(?char+is_lower*1024,*f,1024)
  For i=0 To 1023
    PokeA(*f+1024+i,255!PeekA(*f+i))
  Next i
EndProcedure

Procedure DrawLine(x0.w,y0.w,x1.w,y1.w)
  dx.w = Abs(x1-x0)
  dy.w = Abs(y1-y0)
  sx.w=Sign(x1-x0)
  sy.w=Sign(y1-y0)
  e.w = dx-dy
  
  ;drwlp:
  ;Plot(x0,y0,RGB(255,0,0));Graphic Set Pixel (x0,y0), clr
  ;While(x0<>x1) And (y0<>y1)
  Repeat
    putc(x0,y0)
    ;   If x0 = x1 And y0 = y1:Goto ex_dr:EndIf; Then Exit Loop
    e2.w = 2*e
    If e2 > -dy
      e = e - dy
      x0 = x0 + sx
    EndIf
    If e2 <  dx
      e = e + dx
      y0 = y0 + sy
    EndIf
    ;Wend;Goto drwlp
  Until (x0=x1) And (y0=y1)
  putc(x0,y0)
  ;  ex_dr:
EndProcedure

Procedure fill(x,y)
  putc(x,y)
  ;   draws()
  ;   WindowEvent()
  If x>0 And PeekA(*s+x-1+y*40)=32
    fill(x-1,y)
  EndIf
  If x<40 And PeekA(*s+x+1+y*40)=32
    fill(x+1,y)
  EndIf
  
  If y>0 And PeekA(*s+x+(y-1)*40)=32
    fill(x,y-1)
  EndIf
  
  If y<25 And PeekA(*s+x+(y+1)*40)=32
    fill(x,y+1)
  EndIf
EndProcedure

Procedure check_menu_border()
  For i=0 To 15
    If i=borderc
      checkval=1
    Else
      checkval=0
    EndIf
    SetMenuItemState(0,#bc0+i,checkval)
  Next i
EndProcedure

Procedure loadfile(f$)
If FileSize(f$)=2001
  If ReadFile(0,f$)
    spa$=GetPathPart(f$)
    ;check size
    ReadData(0,*s,2000)
    borderc=ReadAsciiCharacter(0)
    CloseFile(0)
    check_menu_border()
    drawch()
  Else
    MessageRequester("Readfile","Error read "+f$)
  EndIf
  Else
    MessageRequester("Readfile","Unkn filesize "+f$)
  EndIf
EndProcedure


mh=GetSystemMetrics_(#SM_CYMENUSIZE)+GetSystemMetrics_(#SM_CYFIXEDFRAME)
;Debug GetSystemMetrics_(#SM_CYFIXEDFRAME)
If OpenWindow(0, 0, 0, 640+256, 400+mh, v$, #PB_Window_MinimizeGadget|#PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  CanvasGadget(#s, 0, 0, 640, 400+mh,#PB_Canvas_Keyboard)
  CanvasGadget(#ch, 640, 0, 256, 256+16)
  EnableGadgetDrop(#s,#PB_Drop_Files,#PB_Drag_Copy)
  If CreateMenu(0, WindowID(0))
    MenuTitle("File")
    MenuItem(#file_open, "Open"   +Chr(9)+"Ctrl+O")
    MenuItem(#file_save, "Save"   +Chr(9)+"Ctrl+S")
    MenuBar()
    MenuItem(#file_quit, "Close"  +Chr(9)+"Ctrl+Q")
    MenuTitle("Mode")
    MenuItem(#mode_lower, "Lower")
    MenuItem(#mode_upper, "Upper")
    OpenSubMenu("Background")
    For i=0 To 15
      MenuItem(#bc0+i, Str(i))
    Next i
    CloseSubMenu()  
    MenuTitle("Draw")
    MenuItem(#draw_pen, "Pen")
    MenuItem(#draw_line, "line")
    MenuItem(#draw_fill, "fill")
    MenuBar()
    MenuItem(#draw_cls, "Clear screen")
    
    AddKeyboardShortcut(0,#PB_Shortcut_Control | #PB_Shortcut_O,#file_open)
    AddKeyboardShortcut(0,#PB_Shortcut_Control | #PB_Shortcut_S,#file_save)
    AddKeyboardShortcut(0,#PB_Shortcut_Control | #PB_Shortcut_Q,#file_quit)
    SetMenuItemState(0,#mode_upper,1)
    
    check_menu_border()
  EndIf
  
  prepchar()
  
  cls()
  
  If CountProgramParameters()
    loadfile(ProgramParameter(0))
  EndIf
  ;   curchar=120
  ;   fill(10,10)
  ;   drawline(0,0,40,25)
  draws()
  drawch()
  xo=-1
  yo=-1
  Repeat
    Event = WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)&32768
      Break
    EndIf
    Select Event
      Case #PB_Event_GadgetDrop
        loadfile(EventDropFiles())
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #s;-- text draw
            x = GetGadgetAttribute(#s, #PB_Canvas_MouseX)/16
            y = GetGadgetAttribute(#s, #PB_Canvas_MouseY)/16
            Select EventType()
              Case #PB_EventType_KeyDown;--keyboard handling
                If GetGadgetAttribute(#s,#PB_Canvas_Key)=#PB_Shortcut_Delete And GetGadgetAttribute(#s,#PB_Canvas_Modifiers)=0
                  If x<39
                    For xx=x To 38
                      PokeA(*s+y*40+xx,PeekA(*s+y*40+xx+1))
                      PokeA(*s+1000+y*40+xx,PeekA(*s+1000+y*40+xx+1))
                    Next xx
                    PokeA(*s+y*40+39,32)
                    PokeA(*s+1000+y*40+39,14)
                    draws()
                  EndIf
                EndIf
                If GetGadgetAttribute(#s,#PB_Canvas_Key)=#PB_Shortcut_Insert And GetGadgetAttribute(#s,#PB_Canvas_Modifiers)=0
                  For xx=39 To x+1 Step -1
                    PokeA(*s+y*40+xx,PeekA(*s+y*40+xx-1))
                    PokeA(*s+1000+y*40+xx,PeekA(*s+1000+y*40+xx-1))
                  Next xx
                  PokeA(*s+y*40+x,32)
                  PokeA(*s+1000+y*40+x,14)
                  draws()
                EndIf
                ;Ctrl+Del - delete line
                If GetGadgetAttribute(#s,#PB_Canvas_Key)=#PB_Shortcut_Delete And GetGadgetAttribute(#s,#PB_Canvas_Modifiers)&#PB_Canvas_Control
                  If y<>24
                    CopyMemory(*s+(y+1)*40,*s+y*40,(24-y)*40)
                    CopyMemory(*s+1000+(y+1)*40,*s+1000+y*40,(24-y)*40)
                  EndIf
                  FillMemory(*s+40*24,40,32)
                  FillMemory(*s+1000+40*24,40,14)
                  draws()
                EndIf
                ;Ctrl+Insert - insert line
                If GetGadgetAttribute(#s,#PB_Canvas_Key)=#PB_Shortcut_Insert And GetGadgetAttribute(#s,#PB_Canvas_Modifiers)&#PB_Canvas_Control
                  For yy=24 To y+1 Step -1
                    CopyMemory(*s+(yy-1)*40,*s+yy*40,40)
                    CopyMemory(*s+1000+(yy-1)*40,*s+1000+yy*40,40)
                  Next yy
                  FillMemory(*s+y*40,40,32)
                  FillMemory(*s+1000+y*40,40,14)
                  draws()
                EndIf
                ;Shift+Del - delete column
                If GetGadgetAttribute(#s,#PB_Canvas_Key)=#PB_Shortcut_Delete And GetGadgetAttribute(#s,#PB_Canvas_Modifiers)&#PB_Canvas_Shift
                  For yy=0 To 24
                    If x<39
                      For xx=x To 38
                        PokeA(*s+xx+yy*40,PeekA(*s+xx+1+yy*40))
                        PokeA(*s+1000+xx+yy*40,PeekA(*s+1000+xx+1+yy*40))
                      Next xx
                    EndIf
                    PokeA(*s+yy*40+39,32)
                    PokeA(*s+1000+yy*40+39,14)    
                  Next yy
                  draws()
                EndIf
                ;Shift+Ins - insert column
                If GetGadgetAttribute(#s,#PB_Canvas_Key)=#PB_Shortcut_Insert And GetGadgetAttribute(#s,#PB_Canvas_Modifiers)&#PB_Canvas_Shift
                  For yy=0 To 24
                    For xx=39 To x+1 Step -1
                      PokeA(*s+xx+yy*40,PeekA(*s+xx-1+yy*40))
                      PokeA(*s+1000+xx+yy*40,PeekA(*s+1000+xx-1+yy*40))
                    Next xx
                    PokeA(*s+yy*40+x,32)
                    PokeA(*s+1000+yy*40+x,14)    
                  Next yy
                  draws()
                EndIf
                
              Case #PB_EventType_MouseEnter
                SetActiveGadget(#s)
              Case #PB_EventType_MouseMove 
                SetWindowTitle(0,v$+" x:"+Str(x)+",y:"+Str(y)+" char="+Str(PeekA(*s+x+y*40))+" col:"+Str(PeekA(*s+1000+x+y*40)))
                If draw_mode=#draw_pen
                  If GetGadgetAttribute(#s, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton
                    putc(x,y)
                    draws()
                  Else
                    draws()
                  EndIf
                ElseIf draw_mode=#draw_fill
                  draws()
                ElseIf draw_mode=#draw_line
                  If xo<>-1 And yo<>-1
                    CopyMemory(*s,*s+2000,2000)
                    drawline(x,y,xo,yo)
                    draws()
                    CopyMemory(*s+2000,*s,2000)
                  Else
                    draws()
                  EndIf
                EndIf
              Case #PB_EventType_RightClick
                PokeA(*s+x+y*40,32)
                draws()
              Case #PB_EventType_LeftClick
                If draw_mode=#draw_pen
                  putc(x,y)
                  draws()
                ElseIf draw_mode=#draw_fill
                  If PeekA(?petscimap1+curchar&127+128*is_lower)|(curchar&128)<>32
                    ;ShowMemoryViewer(*s,1024)
                    fill(x,y)
                    draws()
                  Else
                    MessageRequester("Fill","Cannot fill space!")
                  EndIf
                ElseIf draw_mode=#draw_line
                  If xo=-1 And yo=-1
                    xo=x
                    yo=y
                  Else
                    drawline(x,y,xo,yo)
                    xo=-1
                    yo=-1
                    draws()
                  EndIf
                EndIf
            EndSelect
          Case #ch;-- choose char
            x = GetGadgetAttribute(#ch, #PB_Canvas_MouseX)/16
            y = GetGadgetAttribute(#ch, #PB_Canvas_MouseY)/16
            If EventType()=#PB_EventType_MouseLeave
              If StartDrawing(CanvasOutput(#ch))
                DrawingMode(#PB_2DDrawing_Outlined)
                Box (prevx*16,prevy*16,16,16,0)
                Box(16*(curchar&15),curchar&$F0,16,16,255)
                StopDrawing()
              EndIf
            EndIf
            If EventType()=#PB_EventType_MouseMove
              cc=y*16+x
              SetWindowTitle(0,v$+" char:"+Str(PeekA(?petscimap1+cc&127+128*is_lower)|(cc&128)))
              drawch()
            EndIf
            If EventType()=#PB_EventType_LeftClick
              If y<16
                curchar=x+16*y
                drawch()
              Else
                curcol=x
                drawch()
              EndIf
            EndIf
        EndSelect
        
      Case #PB_Event_Menu
        Select EventMenu();--menu events
          Case #bc0 To #bc15
            borderc=EventMenu()-#bc0
            check_menu_border()
            draws()
          Case #file_save
            StandardFile$ = GetCurrentDirectory()
            Pattern$ = "Raw Text (*.rawtext)|*.rawtext|All files (*.*)|*.*"
            File$ = SaveFileRequester("Please choose file to save", spa$, Pattern$, 0)
            res=#PB_MessageRequester_Yes
            If File$
              ;check extension
              If SelectedFilePattern()=0
                If LCase(Right(File$,7))<>"rawtext"
                  File$+".rawtext"
                EndIf
              EndIf
              If FileSize(File$)>=0
                res=MessageRequester("File exists","Overwrite?",#PB_MessageRequester_YesNo)
              EndIf
              If res=#PB_MessageRequester_Yes
                If CreateFile(0,File$)
                  spa$=GetPathPart(File$)
                  WriteData(0,*s,2000)
                  WriteAsciiCharacter(0,borderc)
                  CloseFile(0)
                Else
                  MessageRequester("Writefile","Error write "+File$)
                EndIf
              EndIf
            EndIf
          Case #file_open
            ;StandardFile$ = GetCurrentDirectory()
            Pattern$ = "Raw Text (*.rawtext)|*.rawtext|All files (*.*)|*.*"
            File$ = OpenFileRequester("Please choose file to load", spa$, Pattern$, 0)
            If File$
              loadfile(File$)
              If ReadFile(0,File$)
                spa$=GetPathPart(File$)
                ;check size
                ReadData(0,*s,2000)
                borderc=ReadAsciiCharacter(0)
                CloseFile(0)
                draws()
              Else
                MessageRequester("Readfile","Error read "+File$)
              EndIf
            EndIf
          Case #file_quit
            Break
          Case #draw_cls
            cls()
            draws()
          Case #draw_fill
            draw_mode=#draw_fill
          Case #draw_pen
            draw_mode=#draw_pen
          Case #draw_line
            draw_mode=#draw_line
            
          Case #mode_lower
            SetMenuItemState(0,#mode_lower,1)
            SetMenuItemState(0,#mode_upper,0)
            is_lower=1
            prepchar()
            draws()
            drawch()
          Case #mode_upper
            SetMenuItemState(0,#mode_lower,0)
            SetMenuItemState(0,#mode_upper,1)
            is_lower=0
            prepchar()
            draws()
            drawch()
            
        EndSelect
        
    EndSelect
    
  Until Event = #PB_Event_CloseWindow
EndIf

FreeMemory(*f)
FreeMemory(*s)

DataSection
  ; RGB  0 = $000000
  ; RGB  1 = $FFFFFF
  ; RGB  2 = $924A40
  ; RGB  3 = $84C5CC
  ; RGB  4 = $9351B6
  ; RGB  5 = $72B14B
  ; RGB  6 = $483AAA
  ; RGB  7 = $D5DF7C
  ; RGB  8 = $675200
  ; RGB  9 = $C33D00
  ; RGB 10 = $C18178
  ; RGB 11 = $606060
  ; RGB 12 = $8A8A8A
  ; RGB 13 = $B3EC91
  ; RGB 14 = $867ADE
  ; RGB 15 = $B3B3B3
  
  ;http://unusedino.de/ec64/technical/misc/vic656x/colors/
  ; 00 00 00
  ; FF FF FF
  ; 68 37 2B
  ; 70 A4 B2
  ; 6F 3D 86
  ; 58 8D 43
  ; 35 28 79
  ; B8 C7 6F
  ; 6F 4F 25
  ; 43 39 00
  ; 9A 67 59
  ; 44 44 44
  ; 6C 6C 6C
  ; 9A D2 84
  ; 6C 5E B5
  ; 95 95 95
  
  ;https://www.sheep-thrills.net/RetroChallenge_2018_09.html  
  ;      0 / black      :    0   0   0
  ;      1 / white      :  255 255 255
  ;      2 / red        :  136   0   0
  ;      3 / cyan       :  171 255 239
  ;      4 / purple     :  204  68 204
  ;      5 / green      :    0 203  85
  ;      6 / blue       :    0   0 170
  ;      7 / yellow     :  238 238 118
  ;      8 / orange     :  222 136  85
  ;      9 / brown      :  102  67   0
  ;     10 / pink       :  255 119 119
  ;     11 / darkgrey   :   51  51  51
  ;     12 / midgrey    :  119 119 119
  ;     13 / lightgreen :  170 255 102
  ;     14 / lightblue  :    0 136 255
  ;     15 / lightgrey  :  187 187 187
  c64c:
  Data.l $000000, $FFFFFF, $2B3768, $B2A470, $863D6F, $438D58, $792835, $6FC7B8
  Data.l $254F6F, $003943, $59679A, $444444, $6C6C6C, $84D29A, $B55E6C, $959595
  
  char:
  IncludeBinary"c16.bin"
  
  petscimap1:
  Data.a  32, 01, 02, 03, 04, 05, 06, 07, 08, 09, 10, 11, 12, 13, 14, 15
  Data.a  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 46, 44, 59, 33, 63
  Data.a  48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 34, 35, 36, 37, 38, 39
  Data.a 112,110,108,123, 85, 73, 79, 80,113,114, 40, 41, 60, 62, 78, 77
  Data.a 109,125,124,126, 74, 75, 76,122,107,115, 27, 29, 31, 30, 95,105
  Data.a 100,111,121, 98,120,119, 99,116,101,117, 97,118,103,106, 91, 43
  Data.a  82, 70, 64, 45, 67, 68, 69, 84, 71, 66, 93, 72, 89, 47, 86, 42
  Data.a  61, 58, 28, 00,127,104, 92,102, 81, 87, 65, 83, 88, 90, 94, 96
  ;for lower
  Data.a  32, 01, 02, 03, 04, 05, 06, 07, 08, 09, 10, 11, 12, 13, 14, 15
  Data.a  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 46, 44, 59, 33, 63
  Data.a  96, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79
  Data.a  80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 34, 35, 36, 37, 38
  Data.a  48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 43, 45, 42, 61, 39, 00
  Data.a 112,110,108,123,113,114, 40, 41, 95,105, 92,127, 60, 62, 28, 47
  Data.a 109,125,124,126,107,115, 27, 29, 94,102,104, 58, 30, 31, 91,122
  Data.a 100,111,121, 98, 99,119,120,101,116,117, 97,103,106,118, 64, 93
  
  
  ;   Data.a 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30
  ;   Data.a 31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58
  ;   Data.a 59,60,61,62,63,112,114,110,82,70,64,67,68,69,85,73,87,81,79,119,80,107,91,115,78,77
  ;   Data.a 86,121,120,102,74,75,108,123,116,96,106,109,113,125,95,105,118,117,104,92,127,98,124,126,76
  ;   Data.a 111,122,101,84,71,66,93,72,89,103,99,100,94,97,88,83,90,65
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 261
; FirstLine = 242
; Folding = --
; EnableUnicode
; EnableXP
; UseIcon = pp.ico
; Executable = petsciip.exe
; CommandLine = beaver.rawtext